## proxmox-installer 8.3.3

=== Makefile ===
include /usr/share/dpkg/default.mk

PACKAGE = proxmox-installer
BUILDDIR ?= $(PACKAGE)-$(DEB_VERSION_UPSTREAM)

DEB=$(PACKAGE)_$(DEB_VERSION)_$(DEB_HOST_ARCH).deb
ASSISTANT_DEB=proxmox-auto-install-assistant_$(DEB_VERSION)_$(DEB_HOST_ARCH).deb
FIRST_BOOT_DEB=proxmox-first-boot_$(DEB_VERSION)_$(DEB_HOST_ARCH).deb

ALL_DEBS = $(DEB) $(ASSISTANT_DEB) $(FIRST_BOOT_DEB)

DSC=$(PACKAGE)_$(DEB_VERSION).dsc

CARGO ?= cargo
ifeq ($(BUILD_MODE), release)
CARGO_BUILD_ARGS += --release
CARGO_COMPILEDIR := target/release
else
CARGO_COMPILEDIR := target/debug
endif

INSTALLER_SOURCES=$(shell git ls-files) country.dat

PREFIX = /usr
BINDIR = $(PREFIX)/bin
USR_BIN := \
	   proxmox-chroot\
	   proxmox-tui-installer\
	   proxmox-fetch-answer\
	   proxmox-auto-install-assistant \
	   proxmox-auto-installer \
	   proxmox-post-hook

COMPILED_BINS := \
	$(addprefix $(CARGO_COMPILEDIR)/,$(USR_BIN))

SHELL_SCRIPTS := \
	fake-start-stop-daemon \
	policy-disable-rc.d \
	spice-vdagent.sh \
	unconfigured.sh \
	xinitrc

all:

$(BUILDDIR):
	rm -rf $@ $@.tmp; mkdir $@.tmp
	cp -a \
	  .cargo \
	  Cargo.toml \
	  Makefile \
	  Proxmox/ \
	  Xdefaults \
	  banner/ \
	  checktime \
	  country.pl \
	  html/ \
	  interfaces \
	  proxinstall \
	  proxmox-low-level-installer \
	  proxmox-auto-installer/ \
	  proxmox-auto-install-assistant/ \
	  proxmox-fetch-answer/ \
	  proxmox-chroot \
	  proxmox-tui-installer/ \
	  proxmox-installer-common/ \
	  proxmox-post-hook \
	  proxmox-first-boot \
	  test/ \
	  $(SHELL_SCRIPTS) \
	  $@.tmp
	cp -a debian $@.tmp/
	mv $@.tmp $@

country.dat: country.pl
	./country.pl > country.dat.tmp
	mv country.dat.tmp country.dat

deb: $(DEB)
$(ASSISTANT_DEB): $(DEB)
$(FIRST_BOOT_DEB): $(DEB)
$(DEB): $(BUILDDIR)
	cd $(BUILDDIR); dpkg-buildpackage -b -us -uc

test-$(DEB): $(INSTALLER_SOURCES)
	rsync --exclude='test*.img' --exclude='*.deb' --exclude='build' -a * build
	cd build; dpkg-buildpackage -b -us -uc -nc
	mv $(DEB) test-$(DEB)

dsc: $(DSC)
	$(MAKE) clean
	$(MAKE) $(DSC)

$(DSC): $(BUILDDIR)
	cd $(BUILDDIR); dpkg-buildpackage -S -us -uc -d

sbuild: $(DSC)
	sbuild $(DSC)

.PHONY: prepare-test-env
prepare-test-env: cd-info.test country.dat test.img
	rm -rf testdir
	mkdir -p testdir/var/lib/proxmox-installer/
	cp -v country.dat testdir/var/lib/proxmox-installer/
	./proxmox-low-level-installer -t test.img dump-env

.PHONY: test
test: prepare-test-env
	shellcheck $(SHELL_SCRIPTS)
	$(MAKE) -C test check
	$(CARGO) test --workspace $(CARGO_BUILD_ARGS)

DESTDIR=
VARLIBDIR=$(DESTDIR)/var/lib/proxmox-installer
HTMLDIR=$(VARLIBDIR)/html/common

.PHONY: install
install: $(INSTALLER_SOURCES) $(COMPILED_BINS)
	$(MAKE) -C banner install
	$(MAKE) -C Proxmox install
	$(MAKE) -C proxmox-first-boot install
	install -D -m 644 interfaces $(DESTDIR)/etc/network/interfaces
	install -D -m 755 fake-start-stop-daemon $(VARLIBDIR)/fake-start-stop-daemon
	install -D -m 755 policy-disable-rc.d $(VARLIBDIR)/policy-disable-rc.d
	install -D -m 644 country.dat $(VARLIBDIR)/country.dat
	install -D -m 755 unconfigured.sh $(DESTDIR)/sbin/unconfigured.sh
	install -D -m 755 proxinstall $(DESTDIR)/usr/bin/proxinstall
	install -D -m 755 proxmox-low-level-installer $(DESTDIR)/$(BINDIR)/proxmox-low-level-installer
	$(foreach i,$(USR_BIN), install -m755 $(CARGO_COMPILEDIR)/$(i) $(DESTDIR)$(BINDIR)/ ;)
	install -D -m 755 checktime $(DESTDIR)/usr/bin/checktime
	install -D -m 644 xinitrc $(DESTDIR)/.xinitrc
	install -D -m 755 spice-vdagent.sh $(DESTDIR)/.spice-vdagent.sh
	install -D -m 644 Xdefaults $(DESTDIR)/.Xdefaults

$(COMPILED_BINS): cargo-build
.PHONY: cargo-build
cargo-build:
	$(CARGO) build --package proxmox-tui-installer --bin proxmox-tui-installer \
		--package proxmox-auto-installer --bin proxmox-auto-installer \
		--package proxmox-fetch-answer --bin proxmox-fetch-answer \
		--package proxmox-auto-install-assistant --bin proxmox-auto-install-assistant \
		--package proxmox-chroot --bin proxmox-chroot \
		--package proxmox-post-hook --bin proxmox-post-hook \
		$(CARGO_BUILD_ARGS)

%-banner.png: %-banner.svg
	rsvg-convert -o $@ $<

.PHONY: upload
upload: UPLOAD_DIST ?= $(DEB_DISTRIBUTION)
upload: $(ALL_DEBS)
	tar cf - $(ALL_DEBS) | ssh -X repoman@repo.proxmox.com -- upload --product pve,pmg,pbs --dist $(UPLOAD_DIST)

%.img:
	truncate -s 2G $@

%.big.img:
	truncate -s 8G $@

.PHONY: prepare-check-env
prepare-check-env: test-$(DEB)
	rm -rf testdir
	dpkg -X test-$(DEB) testdir
	mkdir -p testdir/run/proxmox-installer/

cd-info.test: PRODUCT ?= pve
cd-info.test:
	printf '%s\n' "PRODUCT='$(or $(PRODUCT), pve)'" >$@.tmp
	printf '%s\n' "PRODUCTLONG='$(or $(PRODUCTLONG), Proxmox VE)'" >>$@.tmp
	printf '%s\n' "RELEASE='$(or $(RELEASE), 42.1)'" >>$@.tmp
	printf '%s\n' "ISORELEASE='$(or $(ISORELEASE), 1)'" >>$@.tmp
	printf '%s\n' "ISONAME='$(or $(ISONAME), proxmox-ve)'" >>$@.tmp
	mv $@.tmp $@

check-pve: prepare-check-env test.img
	rm -f cd-info.test; $(MAKE) cd-info.test
	./proxmox-low-level-installer dump-env -t test.img
	G_SLICE=always-malloc perl -I testdir/usr/share/perl5 testdir/usr/bin/proxinstall -t test.img

check-pve-multidisks: prepare-check-env test.img test2.img test3.img test4.img test5.big.img
	rm -f cd-info.test; $(MAKE) cd-info.test
	./proxmox-low-level-installer dump-env -t test.img,test2.img,test3.img,test4.img,test5.big.img
	G_SLICE=always-malloc perl -I testdir/usr/share/perl5 testdir/usr/bin/proxinstall -t test.img,test2.img,test3.img,test4.img,test5.big.img

check-pve-tui: prepare-check-env test.img
	rm -f cd-info.test; $(MAKE) cd-info.test
	./proxmox-low-level-installer dump-env -t test.img
	testdir/usr/bin/proxmox-tui-installer -t test.img 2>testdir/run/stderr

check-pve-tui-multidisks: prepare-check-env test.img test2.img test3.img test4.img test5.big.img
	rm -f cd-info.test; $(MAKE) cd-info.test
	./proxmox-low-level-installer dump-env -t test.img,test2.img,test3.img,test4.img,test5.big.img
	testdir/usr/bin/proxmox-tui-installer -t test.img,test2.img,test3.img,test4.img,test5.big.img

prepare-check-pmg: prepare-check-env test.img
	rm -f cd-info.test; $(MAKE) \
	    PRODUCT=pmg \
	    PRODUCTLONG="Proxmox Mail Gateway" \
	    ISONAME='proxmox-mail-gateway' \
	    cd-info.test
	./proxmox-low-level-installer dump-env -t test.img

check-pmg: prepare-check-pmg
	G_SLICE=always-malloc perl -I testdir/usr/share/perl5 testdir/usr/bin/proxinstall -t test.img

check-pmg-tui: prepare-check-pmg
	testdir/usr/bin/proxmox-tui-installer -t test.img 2>testdir/run/stderr

prepare-check-pbs: prepare-check-env test.img
	rm -f cd-info.test; $(MAKE) \
	    PRODUCT='pbs' \
	    PRODUCTLONG='Proxmox Backup Server' \
	    ISONAME='proxmox-backup-server' \
	    cd-info.test
	./proxmox-low-level-installer dump-env -t test.img

check-pbs: prepare-check-pbs
	G_SLICE=always-malloc perl -I testdir/usr/share/perl5 testdir/usr/bin/proxinstall -t test.img

check-pbs-tui: prepare-check-pbs
	testdir/usr/bin/proxmox-tui-installer -t test.img 2>testdir/run/stderr

.phony: clean
clean:
	rm -rf target build $(PACKAGE)-[0-9]* testdir
	rm -f $(PACKAGE)*.tar* *.deb packages packages.tmp *.build *.dsc *.buildinfo *.changes
	rm -f test*.img pve-final.pkglist country.dat final.pkglist cd-info.test
	find . -name '*~' -exec rm {} ';'

=== Proxmox/Makefile ===
all:

DESTDIR=
VARLIBDIR=$(DESTDIR)/var/lib/proxmox-installer
PERL5DIR=$(DESTDIR)/usr/share/perl5/Proxmox

#PERL_MODULES=$(shell git ls-files . | grep '.pm$')
PERL_MODULES=\
    Install.pm \
    Install/Config.pm \
    Install/ISOEnv.pm \
    Install/RunEnv.pm \
    Install/StorageConfig.pm \
    Log.pm \
    Sys.pm \
    Sys/Block.pm \
    Sys/Command.pm \
    Sys/File.pm \
    Sys/Net.pm \
    Sys/Udev.pm \
    Sys/ZFS.pm \
    UI.pm \
    UI/Base.pm \
    UI/Gtk3.pm \
    UI/StdIO.pm \

.PHONY: install
install: $(PERL_MODULES)
	for f in $(PERL_MODULES); \
	    do install -D -m 644 "$$f" "$(PERL5DIR)/$$f"; \
	done

.PHONY: clean
clean:

=== banner/Makefile ===
DESTFILE=
INSTALLER_SOURCES=		\
	pmg-banner.png		\
	pve-banner.png		\
	pbs-banner.png		\

%-banner.png: %-banner.svg
	rsvg-convert -o $@ $<

# just for triggering a "build", the actual installation is handled by debhelper
.PHONY: install
install: $(INSTALLER_SOURCES)

=== html/Makefile ===
DESTDIR=
VARLIBDIR=$(DESTDIR)/var/lib/proxmox-installer
HTMLDIR=$(VARLIBDIR)/html/common

all:

.phony: install
install:
	install -D -m 644 pve-installer.css $(HTMLDIR)/pve-installer.css
	install -D -m 644 plus.png $(HTMLDIR)/plus.png
	install -D -m 644 country.htm $(HTMLDIR)/country.htm
	install -D -m 644 license.htm $(HTMLDIR)/license.htm
	install -D -m 644 ipconf.htm $(HTMLDIR)/ipconf.htm
	install -D -m 644 nohds.htm $(HTMLDIR)/nohds.htm
	install -D -m 644 nonics.htm $(HTMLDIR)/nonics.htm
	install -D -m 644 ack_template.htm $(HTMLDIR)/ack_template.htm
	install -D -m 644 success.htm $(HTMLDIR)/success.htm
	install -D -m 644 fail.htm $(HTMLDIR)/fail.htm

.PHONY: clean
clean:
	rm -rf *~

=== proxmox-first-boot/Makefile ===
all:

DESTDIR =
LIBSYSTEMD_DIR = $(DESTDIR)/lib/systemd/system

.PHONY: install
install:
	install -D -m 644 etc/proxmox-first-boot-network-pre.service $(LIBSYSTEMD_DIR)/proxmox-first-boot-network-pre.service
	install -D -m 644 etc/proxmox-first-boot-network-online.service $(LIBSYSTEMD_DIR)/proxmox-first-boot-network-online.service
	install -D -m 644 etc/proxmox-first-boot-multi-user.service $(LIBSYSTEMD_DIR)/proxmox-first-boot-multi-user.service

=== test/Makefile ===
all:

export PERLLIB=..

.PHONY: check
check: test-zfs-arc-max test-run-command test-parse-fqdn test-ui2-stdio \
       test-zfs-get-pool-list test-parse-kernel-cmdline

.PHONY: test-zfs-arc-max
test-zfs-arc-max:
	./zfs-arc-max.pl

.PHONY: test-run-command
test-run-command:
	./run-command.pl

.PHONY: test-parse-fqdn
test-parse-fqdn:
	./parse-fqdn.pl

.PHONY: test-ui2-stdio
test-ui2-stdio:
	./ui2-stdio.pl

.PHONY: test-zfs-get-pool-list
test-zfs-get-pool-list:
	./zfs-get-pool-list.pl

.PHONY: test-parse-kernel-cmdline
test-parse-kernel-cmdline:
	./parse-kernel-cmdline.pl

=== html/pbs/Makefile ===
DESTDIR=

all:

.phony: clean
clean:
	rm -rf *~

=== debian/changelog ===
proxmox-installer (8.3.3) bookworm; urgency=medium

  * common: allow lowercase and uppercase zfs raid levels

  * common: allow lowercase and uppercase btrfs raid levels

 -- Proxmox Support Team <support@proxmox.com>  Wed, 20 Nov 2024 19:50:33 +0100

proxmox-installer (8.3.2) bookworm; urgency=medium

  * fetch-answer: encode unsafe characters in partition label

  * first-boot: multi-user: start after product-specific API proxy

  * install: continue reboot after 30s if post-hook fails

 -- Proxmox Support Team <support@proxmox.com>  Tue, 19 Nov 2024 18:45:53 +0100

proxmox-installer (8.3.1) bookworm; urgency=medium

  * Improve "For more information" paragraph in GUI info bulletin point

  * common: fix deserialization of install config to avoid failing if a
    post-installation webhook is configured.

  * LVM creation: warn about skipping data LV create if maxvz is set <= 4 GiB

 -- Proxmox Support Team <support@proxmox.com>  Tue, 19 Nov 2024 14:30:47 +0100

proxmox-installer (8.3.0) bookworm; urgency=medium

  * fix #5579: auto-installer: add optional first-boot hook script to be
    executed when the freshly installed system is started up the first time.
    One can choose when the script should be started w.r.t. systemd unit
    ordering, either before the network starts to get configured to allow
    adapting or even bootstrap the network settings themselves, then once
    netowrking is available, or once the system is fully booted up.

 -- Proxmox Support Team <support@proxmox.com>  Mon, 18 Nov 2024 22:38:31 +0100

proxmox-installer (8.2.8) bookworm; urgency=medium

  * auto-installer: add default value for partition-label to fix regression
    from new override mechanism

  * install: show hint when making the system bootable that it might take a
    while if multiple disks need to be processed to avoid that users think the
    installer is stuck.

  * install: zfs: rename pre-existing pool named `rpool` also if in degraded
    state for best-effort to avoid that the user needs to do so after the
    installation from the limited initrd environment.

  * fetch-answer, post-hook: rename $format-info to the more widely used
    $schema, now that we still can easily do so without any backwards compat
    implications.

 -- Proxmox Support Team <support@proxmox.com>  Sun, 17 Nov 2024 17:56:01 +0100

proxmox-installer (8.2.7) bookworm; urgency=medium

  * tui: boot disk: align btrfs dialog interface with ZFS equivalent

  * tui: boot disk: use tabbed view for disk options on small screens

  * auto-installer: fix cut-off answer-request charset to state utf-8

  * low-level: install: check for already-existing `rpool` on install

  * low-level: change root password option to contain either plain-text or hash
    and add new `global.root_password_hashed` answer option to the
    auto-installer

  * tui: show background header on fatal setup error

  * tui: use email regex from HTML specification for validation

  * installer-common: do not drop `nomodeset` from target kernel cmdline

  * fetch-answer: allow one to override the partition label the answer file
    should be searched on through the fetch-config file that is setup when
    preparing an ISO. This can help with some limited BMCs/IPMIs where one
    might not be able to control the partition label.

  * fix #5250: allow one to set the compress option for BTRFS

  * expose ZFS ARC size override setting for all products, not just Proxmox VE

  * fix #5536: auto-installer: add `post-installation-webhook` section to
    answer file. When configured, the installer will send a HTTP notification
    to the specified URL after the installation finished successfully.

  * add $format-info meta object to fetch-answer and post-hook requests,
    allowing one to tell when new features can be used in a backward
    compatible way

 -- Proxmox Support Team <support@proxmox.com>  Thu, 14 Nov 2024 22:05:11 +0100

proxmox-installer (8.2.6) bookworm; urgency=medium

  * assistant: ensure the partition UUID stay the same when preparing an ISO
    to keep it bootable on EFI with flash drives as installer medium

 -- Proxmox Support Team <support@proxmox.com>  Wed, 08 May 2024 15:53:33 +0200

proxmox-installer (8.2.5) bookworm; urgency=medium

  * fetch answer: really try lower-case variant of label too

 -- Proxmox Support Team <support@proxmox.com>  Wed, 24 Apr 2024 13:11:42 +0200

proxmox-installer (8.2.4) bookworm; urgency=medium

  * auto-installer: shorten partition label to "PROXMOX-AIS" so that it
    fits in the 11 characters limit for labels when using the FAT file-
    system

  * assistant: fix newline before ':' in help usage text

  * assistant: updated remaining error messages to reworked CLI

  * answer: perform basic input validation for keyboard

 -- Proxmox Support Team <support@proxmox.com>  Wed, 24 Apr 2024 10:55:05 +0200

proxmox-installer (8.2.3) bookworm; urgency=medium

  * also skip installing the proxmox-grub meta package if not booted in EFI
    mode

 -- Proxmox Support Team <support@proxmox.com>  Wed, 24 Apr 2024 00:16:36 +0200

proxmox-installer (8.2.2) bookworm; urgency=medium

  * auto-installer:
    - rename `global.password` option to `global.root_password`
    - move `system.root_ssh_keys` option to `global` section
    - support UTC as timezone
    - drop fetch-from auto mode to avoid complexity and querying (potentially
      untrusted) networks by default
    - rework the default filename suffix that gets added to the default
      output filename of the prepared iso
    - move ssh keys setup to low-level installer, avoiding command injection
    - rework command line options:
      - rename 'install-mode' option to 'fetch-from'
      - rename 'included' fetch-from variant to 'iso'
      - rename 'source' to 'input' and 'target' to 'output'
      - drop all short options for now
      - update help text
    - report every progress update and include text

  * low level installer:


=== debian/control ===
Source: proxmox-installer
Section: perl
Priority: optional
Maintainer: Proxmox Support Team <support@proxmox.com>
Build-Depends: cargo:native,
               debhelper-compat (= 12),
               iproute2,
               iso-codes,
               libgtk3-perl,
               libpve-common-perl,
               librsvg2-bin,
               librust-anyhow-1-dev,
               librust-clap-4+derive-dev,
               librust-cursive-0.21+crossterm-backend-dev,
               librust-glob-0.3-dev,
               librust-hex-0.4-dev,
               librust-native-tls-dev,
               librust-nix-0.26+default-dev,
               librust-regex-1+default-dev (>= 1.7~~),
               librust-rustls-0.21+dangerous-configuration-dev,
               librust-rustls-native-certs-dev,
               librust-serde-1+default-dev,
               librust-serde-json-1+default-dev,
               librust-serde-plain-1+default-dev,
               librust-sha2-0.10-dev,
               librust-toml-0.8-dev,
               librust-ureq-2.10-dev,
               libtest-mockmodule-perl,
               patchelf,
               perl,
               rustc:native,
               shellcheck,
Standards-Version: 4.5.1
Homepage: https://www.proxmox.com

Package: proxmox-installer
Architecture: any
Depends: btrfs-progs,
         chrony,
         eject,
         geoip-bin,
         iproute2,
         libgtk3-perl,
         libgtk3-webkit2-perl,
         libjson-perl,
         lvm2,
         openbox,
         proxmox-kernel-helper,
         squashfs-tools,
         thin-provisioning-tools,
         xorg,
         zfsutils-linux,
         zfs-initramfs,
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends},
Breaks: pbs-installer (<< 7~), pve-installer (<< 7~),
Replaces: pbs-installer (<< 7~), pve-installer (<< 7~),
Description: Installer for Proxmox Projects
 This package contains the graphical installer for:
  * Proxmox VE.
  * Proxmox Mail Gateway.
  * Proxmox Backup Server

Package: proxmox-auto-install-assistant
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Recommends: xorriso,
Description: Assistant to help with automated installations
 Provides a helper that can assist with creating an answer file for a automated
 installation of a Proxmox project, and preparing a official ISO image to use
 this answer file.

Package: proxmox-first-boot
Architecture: any
Depends: ${misc:Depends},
Description: Service which runs on the first system boot for additional setup
 Provides a service which will run on the first boot if the a script was
 configured through the auto-installer.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

export BUILD_MODE=release

%:
	dh $@

override_dh_missing:
	dh_missing --fail-missing

override_dh_strip:
	dh_strip
	for exe in $$(find \
	    debian/proxmox-installer \
	    debian/proxmox-auto-install-assistant \
	    -executable -type f); do \
	  debian/scripts/elf-strip-unused-dependencies.sh "$$exe" || true; \
	done

override_dh_installsystemd:
	# disables all services by default, as we enable them ourselves in
	# the installer
	dh_installsystemd --no-stop-on-upgrade --no-start --no-enable

## proxmox-installer 8.3.9

=== Makefile ===
--- 
+++ 
@@ -19,7 +19,7 @@
 CARGO_COMPILEDIR := target/debug
 endif
 
-INSTALLER_SOURCES=$(shell git ls-files) country.dat
+INSTALLER_SOURCES=$(shell git ls-files) locale-info.json
 
 PREFIX = /usr
 BINDIR = $(PREFIX)/bin
@@ -72,9 +72,9 @@
 	cp -a debian $@.tmp/
 	mv $@.tmp $@
 
-country.dat: country.pl
-	./country.pl > country.dat.tmp
-	mv country.dat.tmp country.dat
+locale-info.json: country.pl
+	./country.pl > $@.tmp
+	mv $@.tmp $@
 
 deb: $(DEB)
 $(ASSISTANT_DEB): $(DEB)
@@ -98,10 +98,10 @@
 	sbuild $(DSC)
 
 .PHONY: prepare-test-env
-prepare-test-env: cd-info.test country.dat test.img
+prepare-test-env: cd-info.test locale-info.json test.img
 	rm -rf testdir
 	mkdir -p testdir/var/lib/proxmox-installer/
-	cp -v country.dat testdir/var/lib/proxmox-installer/
+	cp -v locale-info.json testdir/var/lib/proxmox-installer/
 	./proxmox-low-level-installer -t test.img dump-env
 
 .PHONY: test
@@ -122,7 +122,7 @@
 	install -D -m 644 interfaces $(DESTDIR)/etc/network/interfaces
 	install -D -m 755 fake-start-stop-daemon $(VARLIBDIR)/fake-start-stop-daemon
 	install -D -m 755 policy-disable-rc.d $(VARLIBDIR)/policy-disable-rc.d
-	install -D -m 644 country.dat $(VARLIBDIR)/country.dat
+	install -D -m 644 locale-info.json $(VARLIBDIR)/locale-info.json
 	install -D -m 755 unconfigured.sh $(DESTDIR)/sbin/unconfigured.sh
 	install -D -m 755 proxinstall $(DESTDIR)/usr/bin/proxinstall
 	install -D -m 755 proxmox-low-level-installer $(DESTDIR)/$(BINDIR)/proxmox-low-level-installer
@@ -149,7 +149,7 @@
 .PHONY: upload
 upload: UPLOAD_DIST ?= $(DEB_DISTRIBUTION)
 upload: $(ALL_DEBS)
-	tar cf - $(ALL_DEBS) | ssh -X repoman@repo.proxmox.com -- upload --product pve,pmg,pbs --dist $(UPLOAD_DIST)
+	tar cf - $(ALL_DEBS) | ssh -X repoman@repo.proxmox.com -- upload --product pve,pmg,pbs,pdm --dist $(UPLOAD_DIST)
 
 %.img:
 	truncate -s 2G $@
@@ -220,9 +220,23 @@
 check-pbs-tui: prepare-check-pbs
 	testdir/usr/bin/proxmox-tui-installer -t test.img 2>testdir/run/stderr
 
+prepare-check-pdm: prepare-check-env test.img
+	rm -f cd-info.test; $(MAKE) \
+	    PRODUCT='pdm' \
+	    PRODUCTLONG='Proxmox Datacenter Manager' \
+	    ISONAME='proxmox-datacenter-manager' \
+	    cd-info.test
+	./proxmox-low-level-installer dump-env -t test.img
+
+check-pdm: prepare-check-pdm
+	G_SLICE=always-malloc perl -I testdir/usr/share/perl5 testdir/usr/bin/proxinstall -t test.img
+
+check-pdm-tui: prepare-check-pdm
+	testdir/usr/bin/proxmox-tui-installer -t test.img 2>testdir/run/stderr
+
 .phony: clean
 clean:
 	rm -rf target build $(PACKAGE)-[0-9]* testdir
 	rm -f $(PACKAGE)*.tar* *.deb packages packages.tmp *.build *.dsc *.buildinfo *.changes
-	rm -f test*.img pve-final.pkglist country.dat final.pkglist cd-info.test
+	rm -f test*.img pve-final.pkglist locale-info.json final.pkglist cd-info.test
 	find . -name '*~' -exec rm {} ';'

=== banner/Makefile ===
--- 
+++ 
@@ -3,6 +3,7 @@
 	pmg-banner.png		\
 	pve-banner.png		\
 	pbs-banner.png		\
+	pdm-banner.png		\
 
 %-banner.png: %-banner.svg
 	rsvg-convert -o $@ $<

=== debian/changelog ===
proxmox-installer (8.3.9) bookworm; urgency=medium

  * add preliminary support for new, in-development, PDM for which we plan an
    Alpha release

  * update GUI banner for new PDM project.

  * releases 8.3.5 to 8.3.8 have been folded into this changelog entry due to
    very minor, iterative changes.

  * install: pdm: fix owner and permissions of access config hierarchy

 -- Proxmox Support Team <support@proxmox.com>  Tue, 17 Dec 2024 19:21:06 +0100

proxmox-installer (8.3.4) bookworm; urgency=medium

  * auto installer: log non-json low-level messages into separate file to
    avoid noise.

  * low-level: add proper message to 100% progress ratio update.

  * auto installer: avoid printing unnecessary progress update lines.

 -- Proxmox Support Team <support@proxmox.com>  Mon, 25 Nov 2024 23:28:47 +0100

=== debian/control ===
--- 
+++ 
@@ -16,6 +16,7 @@
                librust-hex-0.4-dev,
                librust-native-tls-dev,
                librust-nix-0.26+default-dev,
+               librust-pretty-assertions-1.4-dev,
                librust-regex-1+default-dev (>= 1.7~~),
                librust-rustls-0.21+dangerous-configuration-dev,
                librust-rustls-native-certs-dev,
@@ -58,9 +59,10 @@
 Replaces: pbs-installer (<< 7~), pve-installer (<< 7~),
 Description: Installer for Proxmox Projects
  This package contains the graphical installer for:
-  * Proxmox VE.
-  * Proxmox Mail Gateway.
+  * Proxmox VE
+  * Proxmox Mail Gateway
   * Proxmox Backup Server
+  * Proxmox Datacenter Manager
 
 Package: proxmox-auto-install-assistant
 Architecture: any
